from ngsolve import *
from netgen.csg import *
import netgen.gui

#mesh = Mesh(unit_cube.GenerateMesh(maxh=0.1))
# ***************************************************
# Generate geometry for a unit cube
# ***************************************************
def Geom_Cube():
   geo_cube = CSGeometry()
   left  = Plane (Pnt(0,0,0), Vec(-1,0,0) ).bc("left")
   right = Plane (Pnt(1,1,1), Vec( 1,0,0) ).bc("right")
   front = Plane (Pnt(0,0,0), Vec(0,-1,0) ).bc("front")
   back  = Plane (Pnt(1,1,1), Vec(0, 1,0) ).bc("back")
   bot   = Plane (Pnt(0,0,0), Vec(0,0,-1) ).bc("bot")
   top   = Plane (Pnt(1,1,1), Vec(0,0, 1) ).bc("top")
   
   cube = left * right * front * back * bot * top
   geo_cube.Add (cube)
   #geo.Draw()
   return geo_cube
   
ngmesh = Geom_Cube().GenerateMesh(maxh=0.1)
#ngmesh.Save("cube.vol")
mesh=Mesh(ngmesh)


fes = H1(mesh, order=3)
gfu = GridFunction(fes)
gfu.Set(x*y*z)


# generate mesh for integration
geom2 = CSGeometry()
z0 = 0.1
cut = Plane(Pnt(0,0,z0), Vec(0,0,1)).bc("cut")
# surface cut as part of the boundary of a brick
geom2.AddSurface (cut, OrthoBrick(Pnt(0,0,0), Pnt(1,1,1)) * cut)
#geom2.AddSurface (cut, Geom_Cube() * cut)
mesh2 = Mesh(geom2.GenerateMesh(maxh=0.2))

Draw (gfu)


# use integration points from mesh2,
# needs point search to evaluate gfu on first mesh
print ("integral = ", Integrate (gfu, mesh2, BND)) 
